open Expression
open Exp2Node

	type exp = Expression.exp
	type conNodeRef = Exp2Node.conNodeRef

	let rec mkConNode ex =
	match !ex with
		|EXP1(opn, ex1) -> mkExp1ConNode opn (mkConNode ex1)
		|EXP2(opn, ex1, ex2) -> mkExp2ConNode opn (mkConNode ex1) (mkConNode ex2)
		|VAR(v) -> mkVarConNode v
		|BVALUE(b) -> mkBoolConNode b
		|VALUE(v) -> mkIntConNode v

