    exception INVALIDSTATE of string

    type exp = Expression.exp
    type assign = NONE | ASSIGN of exp ref list ref * exp ref list ref
    type action =
        INPUT of string * exp ref list ref
      | OUTPUT of string * exp ref list ref
      | TAU
      | DELTA of int
    type ntype = INIT | PROGRESS | ACCEPTANCE
    type node = string * string * exp ref list ref * ntype
    type edge = int * exp ref * assign ref * action ref * int
    val compareNode : node -> node -> int
    val compareEdge :
      edge -> edge -> int
    val is_act_eq : action ref -> action ref -> bool
    val mergeAssign : assign ref -> assign ref -> assign ref
    val action2Assign : action ref -> int -> assign ref
    val action2String : action ref -> string
    val assign2String : assign ref -> string
    val symVal : exp ref list ref -> exp ref list ref

    val substCondition : exp ref -> assign ref -> exp ref

