typedef int bool;
#define TRUE 1
#define FALSE 0

#define MAX_N_VAR 100
#define MAX_N_ENM 100

typedef double REAL;

union Valuetag
{
	//int ivalue;
    float fvalue;
    char svalue[80];
    bool bvalue;
};

typedef struct _ConNode  
{
	union Valuetag NodeValue;
	int  NodeType; // 100 is numeric var, 101 is bool var, 102 is numeric operator(including "+ - * /" ), 103 is numerica comparer(including "==,>,>=,<,<=,!="), 104 is bool operator(including "&& , ||"), 105 is constant, 106 is enum=
	struct _ConNode * right;
	struct _ConNode * left;	
}ConNode;
ConNode* NewConNode(union Valuetag NV, int NT, ConNode * r, ConNode * l);
ConNode* CopyConNode(ConNode* connode);

typedef struct _Constraint
{
	ConNode * root;
	int ID;
}Constraint;
Constraint* NewConstraint(ConNode * node, int id);

typedef struct _ConSet
{
	Constraint* CurCon;
        struct _ConSet * next;
}ConSet;
ConSet* NewConSet(Constraint* c, ConSet * n);
ConSet* CopyConSet(ConSet*);
void GetFmla(ConSet*, int* nu);

typedef struct _Enum
{
	int Nenumtyp; //number of enum type
	char  *EnumName[MAX_N_ENM];	/*  names of enum types */
	int  NeachEnum[MAX_N_VAR];	/* number of each enum types */
	char  *Name[MAX_N_ENM][MAX_N_VAR];	/* enumeration variables */
}Enum;
Enum* NewEnum();

int bonus(ConSet *constraints, Enum *enumv,char **nVarName[],REAL **nVarVal);

